<?php
/**
 * Mod Name: Smilie Groups 1.0
 * Copyright  2006 Smethead
  _____                _   _                    _ 
 / ____|              | | | |                  | |
| (___  _ __ ___   ___| |_| |__   ___  __ _  __| |
 \___ \| '_ ` _ \ / _ \ __| '_ \ / _ \/ _` |/ _` |
 ____) | | | | | |  __/ |_| | | |  __/ (_| | (_| |
|_____/|_| |_| |_|\___|\__|_| |_|\___|\__,_|\__,_|
 */

//PLUGIN HOOKS
$plugins->add_hook("pre_output_page", "sg_add_waymore_link");

//PLUGIN INFORMATION
function smilie_groups_info()
{
	return array(
		"name"				=> "Smilie Groups",
		"description"		=> "With this plugin you can sort your smilies in groups. You can also create, edit or delete smilie groups.",
		"website"			=> "http://www.smethead.tk/",
		"author"			=> "Smethead",
		"authorsite"		=> "mailto:smethead@gmail.com",
		"version"			=> "1.0.2",
		"ei"				=> FALSE,
		"readme" 			=> FALSE,
		"force_readme"		=> FALSE,
		"update"			=> "http://smethead.louhabs.com/plugin_update.php",
		"update_download"	=> TRUE,
	);
}

//PLUGIN ACTIVATE
function smilie_groups_activate(){
	global $db, $mybb;
	
	//ADD SETTINGS
	$sg_group = array(
		"gid"			=> "NULL",
		"name"			=> "Smilie Groups Settings",
		"description"	=> "Settings for smethead\'s \'Smilie Groups\' plugin.",
		"disporder"		=> "20",
		"isdefault"		=> "no",
	);
	$db->insert_query(TABLE_PREFIX."settinggroups", $sg_group);
	$gid = $db->insert_id();
	
	$sg_setting_1 = array(
		"sid"			=> "NULL",
		"name"			=> "sg_backups",
		"title"			=> "Create Backups?",
		"description"	=> "Do you want the \'Smilie Groups\' plugin to create backups of the set-up groups and settings on deactivation? It will then restore the backups once it\'s activated again.<br><small><strong>(Default = On)</strong></small>",
		"optionscode"	=> "onoff",
		"value"			=> "on",
		"disporder"		=> "3",
		"gid"			=> intval($gid),
	);
	$sg_setting_2 = array(
		"sid"			=> "NULL",
		"name"			=> "sg_replace",
		"title"			=> "Replace [get more] link?",
		"description"	=> "Do you want to replace the [get more] link with the [get way more] link from this plugin?<br><small><strong>(If no, the [get way more] link will be placed next to the default one.)</strong></small>",
		"optionscode"	=> "yesno",
		"value"			=> "yes",
		"disporder"		=> "1",
		"gid"			=> intval($gid),
	);
	$sg_setting_3 = array(
		"sid"			=> "NULL",
		"name"			=> "sg_show_empty",
		"title"			=> "Show Empty Groups?",
		"description"	=> "Do you want empty groups to be displayed in the list?<br><small><strong>(Default = No)</strong></small>",
		"optionscode"	=> "yesno",
		"value"			=> "no",
		"disporder"		=> "2",
		"gid"			=> intval($gid),
	);
	
	$db->insert_query(TABLE_PREFIX."settings", $sg_setting_1);
	$db->insert_query(TABLE_PREFIX."settings", $sg_setting_2);
	$db->insert_query(TABLE_PREFIX."settings", $sg_setting_3);
	
	//ALTER TABLES
	$db->query("ALTER TABLE ".TABLE_PREFIX."smilies ADD gid SMALLINT( 5 ) NOT NULL AFTER sid");
	
	//ADD TABLES
	$db->query("CREATE TABLE ".TABLE_PREFIX."sg_smiliegroups (`gid` SMALLINT( 5 ) NOT NULL , `name` VARCHAR( 120 ) NOT NULL , PRIMARY KEY ( `gid` )) ");
	$smiliegroup = array(
		"gid"	=> "0",
		"name"	=> "Other Smilies",
	);
	$db->insert_query(TABLE_PREFIX."sg_smiliegroups", $smiliegroup);
		
	
	//RESTORE BACKUPS
	if($db->table_exists(TABLE_PREFIX."sg_backup")){
		$createbackups = $db->query("SELECT content FROM ".TABLE_PREFIX."sg_backup WHERE name='sg_backups'");
		$createbackupsarray = $db->fetch_array($createbackups);
		if($createbackupsarray['content'] == "on" || $mybb->settings['sg_backups'] == "on"){
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."sg_backup WHERE type='setting' ");
			while($backupq = $db->fetch_array($query)){
				$backup = array(
					"value"	=> $backupq['content'],
				);
				$db->update_query(TABLE_PREFIX."settings", $backup, "name='".$backupq['name']."'");
			}
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."sg_backup WHERE type='smiley' ");
			while($backupq = $db->fetch_array($query)){
				$backup = array(
					"gid"	=> $backupq['content'],
				);
				$db->update_query(TABLE_PREFIX."smilies", $backup, "sid='".$backupq['name']."'");
			}
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."sg_backup WHERE type='smilegroup' ");
			while($backupq = $db->fetch_array($query)){
				if($backupq['name'] != 0){
					$backup = array(
						"gid"	=> $backupq['name'],
						"name"	=> $backupq['content'],
					);
					$db->insert_query(TABLE_PREFIX."sg_smiliegroups", $backup);
				}else{
					$backup = array(
						"gid"	=> 0,
						"name"	=> $backupq['content'],
					);
					$db->update_query(TABLE_PREFIX."sg_smiliegroups", $backup, "gid='0'");
				}
			}
		}elseif($mybb->settings['sg_backups'] == "off"){
			$backup = array(
				"value"		=> "off",
			);
			$db->update_query(TABLE_PREFIX."settings", $backup, "name='sg_backups'");
		}
	}
	
	//REBUILD SETTINGS FILE
	sg_rebuildsettings();
	
	//ADD TEMPLATES
	$sg_template_1 = array(
		"tid"			=> "NULL",
		"title"			=> 'sg_misc_smilies_popup',
		"template"		=> '<html>
<head>
<title>$settings[bbname] - $lang->sg_smilies_listing</title>
$headerinclude
</head>
<body>
<table cellspacing="0" cellpadding="0" border="0" width="100%" align="center">
<tr><td class="tborder">
<table border="0" cellspacing="$theme[borderwidth]" cellpadding="$theme[tablespace]" width="100%">
<tr>
<td class="thead" colspan="4"><strong>$lang->sg_smilies_listing</strong></td>
</tr>
<tr>
<td class="tcat" colspan="4"><span class="smalltext">$lang->sg_click_to_add</span></td>
</tr>
$smilies
<tr>
<td class="thead" colspan="4" align="center"><span class="smalltext">[<a href="javascript:window.close();">$lang->sg_close_window</a>]&nbsp;[<a href="javascript:history.go(-1);">$lang->sg_go_back</a>]</span></td>
</tr>
</table>
</td></tr>
</table>
</td></tr>
<tr><td colspan=\"2\"><div style=\"float:right;\"><font size=\"-3\">Smilie Groups  2006 <a href=\"http://www.smethead.tk\" target=\"_blank\"><b>smethead</b></a></font></div></td></tr>
</table>
</body>
</html>',
		"sid"			=> "-1",
	);
	$sg_template_2 = array(
		"tid"			=> "NULL",
		"title"			=> 'sg_smilies_popup',
		"template"		=> '<html>
<head>
<title>$settings[bbname] - $lang->sg_group_listing</title>
$headerinclude
</head>
<body>
<table cellspacing="0" cellpadding="0" border="0" width="100%" align="center">
<tr><td class="tborder">
<table border="0" cellspacing="$theme[borderwidth]" cellpadding="$theme[tablespace]" width="100%">
<tr>
<td class="thead" colspan="4"><strong>$lang->sg_group_listing</strong></td>
</tr>
<tr>
<td class="tcat" colspan="4"><span class="smalltext">$lang->sg_group_select</span></td>
</tr>
$smilies
<tr>
<td class="thead" colspan="4" align="center"><span class="smalltext">[<a href="javascript:window.close();">$lang->sg_close_window</a>]</span></td>
</tr>
</table>
</td></tr>
</table>
</td></tr>
<tr><td colspan=\"2\"><div style=\"float:right;\"><font size=\"-3\">Smilie Groups  2006 <a href=\"http://www.smethead.tk\" target=\"_blank\"><b>smethead</b></a></font></div></td></tr>
</table>
</body>
</html>',
		"sid"			=> "-1",
	);
	$sg_template_3 = array(
		"tid"			=> "NULL",
		"title"			=> 'sg_smilies_popup_group',
		"template"		=> '<tr><td class="$class" align="center"><a href="sg_smilies.php?group=true&gid=$smilie[gid]">$group_smilie</a></td>
<td class="$class"><a href="sg_smilies.php?group=true&gid=$smilie[gid]">$smilie[name]</a></td></tr>',
		"sid"			=> "-1",
	);
	
	$db->insert_query(TABLE_PREFIX."templates", $sg_template_1);
	$db->insert_query(TABLE_PREFIX."templates", $sg_template_2);
	$db->insert_query(TABLE_PREFIX."templates", $sg_template_3);
	
	//EDIT TEMPLATES
	require "./inc/adminfunctions_templates.php";
	find_replace_templatesets("smilieinsert",'#\$getmore#', '<!-- SG_1_0b -->$getmore<!-- SG_1_0 -->');
	find_replace_templatesets("smilieinsert_getmore",'#getmore</a>]#', 'getmore</a>]<!-- SG_link_1_0 -->');
	
	//UPDATE FILES
	//admin/index.php
	$string = 'makenavoption($lang->nav_smilie_manager, "smilies.php?action=modify");';
	$replacement = 'makenavoption($lang->nav_smilie_manager, "sg_smilies.php?action=modify");';
	// open file
		$fh = fopen('./admin/index.php', "r") or cperror("Could not open file!"); //DO NOT USE $FILENAME!!!
	// read file contents
		$data = fread($fh, filesize('./admin/index.php')) or cperror("Could not read file!");
	// close file
		fclose($fh);
	//replace
		$newdata = preg_replace('#'.preg_quote($string).'#',$replacement,$data);
	// open file
		$fw = fopen('./admin/index.php', "w") or cperror('Could not open file!'); //DO NOT USE $FILENAME!!!
	// write to file
		$fb = fwrite($fw, $newdata) or cperror('Could not write to file');
	// close file
		fclose($fw);
}

//PLUGIN DEACTIVATE
function smilie_groups_deactivate(){
	global $mybb, $db;
	
	//CREATE BACKUPS
	if($mybb->settings['sg_backups'] == "on"){
		if(!$db->table_exists(TABLE_PREFIX."sg_backup")){
			$db->query("CREATE TABLE ".TABLE_PREFIX."sg_backup (`type` VARCHAR( 10 ) NOT NULL ,`name` VARCHAR( 20 ) NOT NULL ,`content` VARCHAR( 120 ) NOT NULL) ");
		}
		$db->query("DELETE FROM ".TABLE_PREFIX."sg_backup WHERE 1=1 ");
		$query = $db->query("SELECT name, value FROM ".TABLE_PREFIX."settings WHERE name IN('sg_backups', 'sg_replace', 'sg_show_empty')");
		while($sg_setting = $db->fetch_array($query)){
			$sg_backup_settings = array(
				"type"		=> "setting",
				"name"		=> $sg_setting['name'],
				"content"	=> $sg_setting['value'],
			);
			$db->insert_query(TABLE_PREFIX."sg_backup", $sg_backup_settings);
		}
		$query = $db->query("SELECT sid, gid FROM ".TABLE_PREFIX."smilies WHERE gid != 0");
		while($sg_smiley = $db->fetch_array($query)){
			$sg_backup_smiley = array(
				"type"		=> "smiley",
				"name"		=> $sg_smiley['sid'],
				"content"	=> $sg_smiley['gid'],
			);
			$db->insert_query(TABLE_PREFIX."sg_backup", $sg_backup_smiley);
		}
		$query = $db->query("SELECT gid, name FROM ".TABLE_PREFIX."sg_smiliegroups WHERE 1=1 ");
		while($sg_smiliegroup = $db->fetch_array($query)){
			$sg_backup_smiliegroup = array(
				"type"		=> "smilegroup",
				"name"		=> $sg_smiliegroup['gid'],
				"content"	=> $sg_smiliegroup['name'],
			);
			$db->insert_query(TABLE_PREFIX."sg_backup", $sg_backup_smiliegroup);
		}
	}elseif($mybb->settings['sg_backups'] == "off"){
		if(!$db->table_exists(TABLE_PREFIX."sg_backup")){
			$db->query("CREATE TABLE ".TABLE_PREFIX."sg_backup (`type` VARCHAR( 10 ) NOT NULL ,`name` VARCHAR( 20 ) NOT NULL ,`content` VARCHAR( 120 ) NOT NULL) ");
		}
		$sg_backup_setting = array(
			"type"		=> "setting",
			"name"		=> "sg_backups",
			"content"	=> "off",
		);
		if($db->query("SELECT name FROM ".TABLE_PREFIX."sg_backup WHERE name='sg_backups'")){
			$db->update_query(TABLE_PREFIX."sg_backup", $sg_backup_setting, "name='sg_backups'");
		}else{
			$db->insert_query(TABLE_PREFIX."sg_backup", $sg_backup_setting);
		}
	}
	//ALTER TABLES
	$db->query("ALTER TABLE ".TABLE_PREFIX."smilies DROP gid");
	
	//REMOVE TABLES
	$db->query("DELETE FROM ".TABLE_PREFIX."sg_smiliegroups WHERE 1=1 ");
	$db->query("DROP TABLE ".TABLE_PREFIX."sg_smiliegroups ");
	
	//DELETE SETTINGS
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN('sg_backups', 'sg_replace', 'sg_show_empty')");
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='Smilie Groups Settings'");
	
	//DELETE ALL TEMPLATES
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title IN('sg_misc_smilies_popup', 'sg_smilies_popup', 'sg_smilies_popup_group', 'sg_get_way_more_link')");

	//REVERT TEMPLATES
	require "./inc/adminfunctions_templates.php";
	find_replace_templatesets("smilieinsert",'#<!-- SG_1_0 -->#', '', 0);
	find_replace_templatesets("smilieinsert",'#<!-- SG_1_0b -->#', '', 0);
	find_replace_templatesets("smilieinsert_getmore",'#<!-- SG_link_1_0 -->#', '', 0);
	
	//REVERT FILES
	//admin/index.php
	$replacement = 'makenavoption($lang->nav_smilie_manager, "smilies.php?action=modify");';
	$string = 'makenavoption($lang->nav_smilie_manager, "sg_smilies.php?action=modify");';
	// open file
		$fh = fopen('./admin/index.php', "r") or cperror("Could not open file!"); //DO NOT USE $FILENAME!!!
	// read file contents
		$data = fread($fh, filesize('./admin/index.php')) or cperror("Could not read file!");
	// close file
		fclose($fh);
	//replace
		$newdata = preg_replace('#'.preg_quote($string).'#',$replacement,$data);
	// open file
		$fw = fopen('./admin/index.php', "w") or cperror('Could not open file!'); //DO NOT USE $FILENAME!!!
	// write to file
		$fb = fwrite($fw, $newdata) or cperror('Could not write to file');
	// close file
		fclose($fw);
}

//CUSTOM REBUILDSETTINGS FUNCTION
function sg_rebuildsettings() {
	global $db;
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."settings ORDER BY title ASC");
	while($setting = $db->fetch_array($query)) {
		$setting['value'] = addslashes($setting['value']);
		$settings .= "\$settings['".$setting['name']."'] = \"".$setting['value']."\";\n";
	}
	$settings = "<?php\n/*********************************\ \n  DO NOT EDIT THIS FILE, PLEASE USE\n  THE SETTINGS EDITOR\n\*********************************/\n\n$settings\n?>";
	$file = fopen("./inc/settings.php", "w");
	fwrite($file, $settings);
	fclose($file);
}

//PLUGIN HOOK FUNCTIONS
function sg_add_waymore_link($page)
{
	global $lang, $mybb;
	$language = $mybb->settings['bblanguage'];
	if(!file_exists("./inc/languages/$language/sg.lang.php")){
		$lang->setLanguage("english");
	}
	$lang->load("sg");
	$lang->setLanguage($mybb->settings['bblanguage']);
	if($mybb->settings['sg_replace'] == "yes"){
		$page = preg_replace('#<!-- SG_1_0b -->#',"<!-- ", $page);
		$page = preg_replace('#<!-- SG_1_0 -->#'," --><!-- SG_1_0 -->", $page);
		$page = preg_replace('#<!-- SG_link_1_0 -->#',"", $page);
	}
	if(preg_match('#<!-- SG_link_1_0 -->#', $page)){
		$page = preg_replace('#<!-- SG_link_1_0 -->#',"&nbsp;[<a href=\"javascript:popupWin('sg_smilies.php','sminsert',240,280);\">$lang->sg_smilieinsert_getwaymore</a>]", $page);
	}else{
		$page = preg_replace('#<!-- SG_1_0 -->#',"<tr><td class=\"trow2\" align=\"center\"><span class=\"smalltext\"><strong>[<a href=\"javascript:popupWin('sg_smilies.php','sminsert',240,280);\">$lang->sg_smilieinsert_getwaymore</a>]</strong></td></tr>", $page);
	}
	return $page;
}
?>